<!DOCTYPE html>
<html lang="en">
<head>
  <title>Simple Array to Tree Format with JQuery and php</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <link rel="stylesheet" href="src/jquery.treefilter.css">
</head>
<body class="container">

  <h2 class="text-danger">Simple Array to Tree Format with JQuery and php</h2>
  <table id="result" class="table table-striped"></table>
  <div id="loader-icon"><i class="fa fa-refresh fa-spin" style="font-size:20px"></i></div>

</body>
<script src="//ajax.googleapis.com/ajax/libs/jquery/1.11.2/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
<script src="src/jquery.treefilter.js"></script>

<script>
 var arr = [
        {'id':1 ,'name':"Ram" ,'parentid' : 0},
        {'id':4 ,'name':"Shyam" ,'parentid' : 5},
        {'id':3 ,'name':"Mohan" ,'parentid' : 1},
        {'id':5 ,'name':"Sohan" ,'parentid' : 0},
        {'id':6 ,'name':"Rohan" ,'parentid' : 0},
        {'id':2 ,'name':"Babita" ,'parentid' : 1},
        {'id':7 ,'name':"Pankaj" ,'parentid' : 4},
        {'id':8 ,'name':"Ramu" ,'parentid' : 1}
      ];
    function createTree(arr) {
      var tree = [],
          mappedArr = {},
          arrElem,
          mappedElem;

      // First map the nodes of the array to an object -> create a hash table.
      for(var i = 0, len = arr.length; i < len; i++) {
        arrElem = arr[i];
        mappedArr[arrElem.id] = arrElem;
        mappedArr[arrElem.id]['children'] = [];
      }


      for (var id in mappedArr) {
        if (mappedArr.hasOwnProperty(id)) {
          mappedElem = mappedArr[id];
          // If the element is not at the root level, add it to its parent array of children.
          if (mappedElem.parentid) {
            mappedArr[mappedElem['parentid']]['children'].push(mappedElem);
          }
          // If the element is at the root level, add it to first level elements array.
          else {
            tree.push(mappedElem);
          }
        }
      }
      return tree;
    }
var tree = createTree(arr);
document.body.innerHTML += "<pre>" + (JSON.stringify(tree, null, " "));
</script>
</html>